<script>
import { mapGetters, mapState } from 'vuex';

import * as animRigApiRoutes from '~/helpers/api-routes/anim-rig.js';
import * as projectsApiRoutes from '~/helpers/api-routes/projects.js';
import * as librariesHelpers from '~/helpers/libraries.js';

export default {
  name: `page-index`,
  data() {
    return {
      showNewProjectModal: false,
      newProjectName: ``,
    };
  },
  computed: {
    ...mapState({
      currentProject: (state) => state.projects.currentProject,
    }),
    ...mapGetters('projects', [ 'activeProjects', 'projectLibraries' ]),
    libraries() {
      return librariesHelpers.computeTree(this.projectLibraries);
    },
  },
  methods: {
    async createProject() {
      const data = { name: this.newProjectName };
      try {
        const project = await this.$axios.$post(projectsApiRoutes.create(), data);
        this.$store.commit(`projects/addProject`, project);
        await this.$store.commit(`projects/setCurrentProject`, { id: project.id, vue: this });
      } catch (err) {
        this.$notify({ type: `error`,
                       title: this.$t(`errors.create-project.title`),
                       text: this.$t(`errors.create-project.content.${err.response.data.name}`),
                       duration: 4000, });
      } finally {
        this.showNewProjectModal = false;
      }
    },
    async setCurrentProject(id) {
      await this.$store.commit(`projects/setCurrentProject`, { id, vue: this });
    },
    async toggleLibraryFavorite (libName, on) {
      const lib = await this.$axios.$put(
        animRigApiRoutes.updateLibraryFavorite({ name: libName }),
        { favorite: on },
        { params: { getPoses: true } },
      );
      await this.$store.commit(`projects/setCurrentProjectLib`, { lib });
    },
  },
}
</script>

<template>
  <div>
    <cbr-modal
      v-model="showNewProjectModal"
      :title="$t(`misc.create-new-project`)"
      :on-cancel="() => showNewProjectModal = false"
      :on-confirm="createProject"
      :confirm-text="$t(`common.create`)"
    >
      <v-text-field
        v-model="newProjectName"
        hide-details
        dense
        :placeholder="$t(`common.name`)"
      ></v-text-field>
    </cbr-modal>

    <template v-if="currentProject">
      <div class="text-h5">
        {{ $tc(`anim-rig.user-libs.title`, 2) }}
      </div>
      <v-divider class="my-4" />
      <v-simple-table>
        <thead>
          <tr>
            <th></th>
            <th>
              Name
            </th>
            <th>
              Owner
            </th>
            <th>
              Number of poses
            </th>
          </tr>
        </thead>
        <tbody>
          <tr
            v-for="lib in libraries"
            :key="lib.id"
          >
            <td class="text-left">
              <v-btn
                icon
                class="mr-2"
                @click.stop="() => toggleLibraryFavorite(lib.name, !lib.favorite)"
              >
                <v-icon>
                  {{ lib.favorite ? `mdi-star` : `mdi-star-outline` }}
                </v-icon>
              </v-btn>
              <v-icon v-if="lib.public">mdi-web</v-icon>
              <v-icon v-if="!lib.active">mdi-cancel</v-icon>
            </td>
            <td>
              <router-link :to="{ path: localePath(`/anim-rig/${lib.name}`), query: $route.query }">
                {{ '\xA0\xA0'.repeat(lib.indent) }}
                <v-icon x-small v-if="lib.indent > 0">mdi-subdirectory-arrow-right</v-icon>
                {{ lib.name }}
              </router-link>
            </td>
            <td>{{ lib.owner }}</td>
            <td>{{ lib.poses ? lib.poses.length : 0 }}</td>
          </tr>
        </tbody>
      </v-simple-table>
    </template>
    <template v-else-if="activeProjects">
      <template v-if="activeProjects.length === 0">
        <div class="projects-column">
          <v-btn large outlined @click="showNewProjectModal = true">
            {{ $t(`misc.create-new-project`) }}
          </v-btn>
        </div>
      </template>
      <template v-else>
        <div class="projects-column">
          <v-btn v-for="project in activeProjects"
                :key="project.id"
                large
                outlined
                @click="setCurrentProject(project.id)"
          >{{ project.name }}</v-btn>
        </div>
      </template>
    </template>
  </div>
</template>

<style scoped>
.projects-column {
  display: flex;
  flex-direction: column;
  align-items: center;
  width: 100%;
  padding-top: 2rem;
}
.projects-column > *:not(:last-child) {
  margin-bottom: 1rem;
}
.projects-column button {
  width: 50vw;
}
</style>
